<template>
    <el-button
        @click="toggleDark()"
        style="
            width: 30px;
            height: 30px;
            padding: 1.5rem;
            position: absolute;
            right: 0;
            margin-right: 0.5rem;
        "
    >
        <img :src="isDark ? `/svg/moon.svg` : `/svg/sun.svg`" alt="SVG" />
    </el-button>

    <div class="login-container">
        <el-card v-loading="loading" class="login-card">
            <div class="logo-container margin-bottom-md">
                <img class="logo" src="imgs/logo.jpg" />
            </div>
            <h2 class="no-margin">Register</h2>
            <p
                class="no-margin-top"
                @click="
                    () => {
                        resetForm();
                        router.push('login');
                    }
                "
            >
                Login here.
            </p>
            <el-form
                ref="formRef"
                :model="form"
                :size="formSize"
                :rules="rules"
            >
                <el-form-item
                    v-for="item in formItems"
                    :prop="item.id"
                    :rules="item.rule"
                >
                    <el-input
                        :class="item.class"
                        :type="item.type"
                        :id="item.id"
                        v-model="form[item.id]"
                        :placeholder="item.placeholder"
                        :show-password="item.type == 'password'"
                    />
                </el-form-item>

                <el-form-item class="margin-top-md">
                    <el-button @click="register">Register</el-button>
                    <el-button @click="resetForm">Reset</el-button>
                </el-form-item>
            </el-form>
        </el-card>
    </div>
</template>

<style lang="scss" scoped>
@import "../../../../sass/app.scss";

img {
    cursor: pointer;
}

h2,
p {
    color: var(--el-color-primary);
}

p:hover {
    cursor: pointer;
    color: hsl(0, 0%, 69%);
}

.login-container {
    display: flex;
    justify-content: center;
    align-items: center;
    height: 800px;
}

.login-card {
    width: 400px;
    max-width: 90%;
    padding: 20px;
    --el-card-border-color: none;
}

.el-button {
    --el-button-hover-bg-color: none;
}
.logo-container {
    width: 100%;
    display: flex;
    align-items: center;
    justify-content: center;
}
.logo {
    width: 150px;
    height: 150px;
    border-radius: 100%;
    box-shadow: 1px 5px 1px rgb(104, 104, 104);
}
</style>

<script setup>
import { ref, onMounted, onBeforeUnmount } from "vue";
import { useRouter } from "vue-router";
import userHandler from "../../helpers/userHandler";
import formHelper from "../../helpers/form";
import { useDark, useToggle } from "@vueuse/core";
import { ElMessageBox } from "element-plus";

const router = useRouter();
const { formSize, formRef, form, resetForm, rules } = formHelper;
const { loading, performRequest } = userHandler;
const formItems = ref([
    {
        id: "name",
        placeholder: "Name",
        type: "text",
        rule: [rules.required],
    },
    {
        id: "email",
        placeholder: "Email",
        type: "email",
    },
    {
        id: "address",
        placeholder: "Address",
        type: "text",
    },
    {
        id: "phone_number",
        placeholder: "Phone Number",
        type: "phone",
        rule: [rules.required],
    },
    {
        id: "password",
        placeholder: "Password",
        type: "password",
    },
    {
        id: "password_confirmation",
        placeholder: "Confirm Password",
        type: "password",
        rule: [rules.password_confirmation],
    },
]);

const register = async () => {



    ElMessageBox.confirm(
        "Please make sure that your credentials are correct, you need to verify your account later using email or phone number, so make sure it is correct.",
        "Warning",
        {
            cancelButtonText: "Cancel",
            confirmButtonText: "Confirm",
            type: "warning",
        }
    ).then(async () => {
        const URL_register = "/api/user/register";
        const payloadProperties = [
            "name",
            "email",
            "address",
            "phone_number",
            "password",
            "password_confirmation",
        ];
        const requestType = "register";
        await performRequest(URL_register, payloadProperties, requestType, router);
    }).catch((error) => {
            console.log(error);
  
    })


   
};

const handleRegister = (event) => {
    if (event.keyCode === 13) {
        event.preventDefault();
        register();
    }
};

onMounted(() => {
    document.body.addEventListener("keydown", handleRegister);
});

onBeforeUnmount(() => {
    document.body.removeEventListener("keydown", handleRegister);
});

const isDark = useDark();
const toggleDark = useToggle(isDark);
</script>
